import es, popuplib, random, gamethread, math
from dnds import *
info = es.AddonInfo()
info.name = 'D&DSource Mod - PVKII'
info.version = '0.0.1 Python'
info.url = 'http://addons.eventscripts.com/addons/view/dnds'
info.basename = 'pvkiidnds'
info.author = 'J3ff Hoogland'
#Begin Events
#Local Events
def player_spawn(ev):
    userid = int(ev['userid'])
    Character = dnds.getPlayer(userid)['Character']
    Playerlib = dnds.getPlayer(userid)['playerlib']
    Player = dnds.getPlayer(userid)['Player']
    for x in ['wind used','word used']:
        Player.key[x] = 0
    if len(Character.key['classes']):
        Class = Character.key['classes'].keys()[0]
    else:
        Class = None
    if Class:
        Player.key['healing surges'] = dndsClasses[Class]['healing surges']+dnds.statMod(Character['abilities']['Constitution'])
        es.setplayerprop(userid, 'CPVK2Player.m_iHealth', dnds.Classes[Class]['health']+(Character['abilities']['Constitution']*10))
        es.setplayerprop(userid, 'CPVK2Player.m_iMaxHealth', dnds.Classes[Class]['health']+(Character['abilities']['Constitution']*10))
        es.setplayerprop(userid, 'CPVK2Player.m_iArmor', dnds.Classes[Class]['armor'])
        es.setplayerprop(userid, 'CPVK2Player.m_iMaxArmor', dnds.Classes[Class]['armor'])
        Playerlib.set('model', dnds.Classes[Class]['model'])
        es.server.queuecmd('est_stripplayer %s'%userid)
        for x in dnds.Classes[Class]['weapons']:
            es.server.queuecmd('es_xgive %s %s'%(userid, x))
        for x in dnds.Classes[Class]['ammo']:
            gamethread.delayed(0, es.setplayerprop, (userid, 'CBasePlayer.localdata.m_iAmmo.%s'%x, dnds.Classes[Class]['ammo'][x]))
def player_damage(ev):
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    damage = int(ev['dmg_health'])
    Character = dnds.getPlayer(userid)['Character']
    Classes = Character.key['classes'].keys()
    if 'Cleric' in Classes:
        level = Character.key['classes']['Cleric']['level']
        if level >= 2:
            Heal(userid, damage/10)
#End Local Events
#Global Events
#End Global Events
#End Events
#Commands Methods
#Cleric's word command
def wordcmd():
    userid = int(es.getcmduserid())
    if not dnds.getPlayer(userid)['Player'].key['word used']:
        if 'Cleric' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            es.ServerVar('_dnds_temp').set(0)
            es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
            gamethread.delayed(0, wordRun, (userid))
        else:
            es.tell(userid, '#multi', dnds.text('wordcmd 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('wordcmd 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def wordRun(userid):
    target = int(es.Servervar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        level = dnds.getPlayer(userid)['Character']['classes']['Cleric']
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 115+(level*5):
            dnds.getPlayer(userid)['Player'].key['word used'] = 1
            gamethread.delayed(15, wordWipe, (userid))
            HealingSurge(target)
            if level < 6:
                amount = random.randint(1, 6)
            elif level < 11:
                amount = random.randint(2, 12)
            elif level < 16:
                amount = random.randint(3, 18)
            elif level < 21:
                amount = random.randint(4, 24)
            elif level < 26:
                amount = random.randint(5, 30)
            else:
                amount = random.randint(6, 36)
            Heal(target, amount)
            es.tell(userid, '#multi', dnds.text('wordRun 1',{'name':es.getplayername(target),'amount':amount},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('wordRun 2',{'name':es.getplayername(target)},dnds.getPlayer(userid)['playerlib'].get('lang')))
def wordWipe(userid):
    dnds.getPlayer(userid)['Player'].key['word used'] = 0
#Begin +wind and -wind
def WindOn():
    userid = int(es.getcmduserid())
    if not dnds.getPlayer(userid)['Player'].key['wind used']:
        if dnds.getPlayer(userid)['Player'].key['healing surges']:
            dnds.getPlayer(userid)['Player'].key['wind on'] = 1
            dnds.getPlayer(userid)['Player'].Delayed(1, WindLoop, (userid, 1))
            dnds.getPlayer(userid)['Player'].Freeze()
        else:
            es.tell(userid, '#multi', dnds.text('WindOn 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('WindOn 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def WindOff():
    userid = int(es.getcmduserid())
    dnds.getPlayer(userid)['Player'].UnFreeze()
    dnds.getPlayer(userid)['Player'].key['wind on'] = 0
def WindLoop(userid, count):
    if count < 4 and dnds.getPlayer(userid)['Player'].key['wind on']:
        dnds.getPlayer(userid)['Player'].Delayed(1, WindLoop, (userid, count+1))
    else:
        WindRun(userid)
def WindRun(userid):
    dnds.getPlayer(userid)['Player'].key['wind used'] = 1
    es.tell(userid, '#multi', dnds.text('WindRun 1',{'surge':Surge,'remaining':dnds.getPlayer(userid)['Player'].key['healing surges']},dnds.getPlayer(userid)['playerlib'].get('lang')))
    dnds.getPlayer(userid)['Player'].Delayed(30, WindWipe, userid)
def WindWipe(userid):
    dnds.getPlayer(userid)['Player'].key['wind used'] = 0
    if dnds.getPlayer(userid)['Player'].key['healing surges']:
        es.tell(userid, '#multi', dnds.text('WindWipe 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#End Command Methods
#Global Methods
def HealingSurge(userid):
    if dnds.getPlayer(userid)['Player'].key['healing surges']:
        Character = dnds.getPlayer(userid)['Character']
        Class = Character.key['classes'].keys()[0]
        Surge = ((dnds.Classes[Class]['health']+(Character['abilities']['Constitution']*10))/2)/2
        Heal(userid, Surge)
        dnds.getPlayer(userid)['Player'].key['healing surges'] -= 1
def Heal(userid, amount):
    if not dnds.getPlayer(userid)['playerlib'].get('isdead'):
        Health = int(es.getplayerprop(userid, 'CPVK2Player.m_iHealth'))
        MaxHealth = int(es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth'))
        if (Health+amount) <= MaxHealth:
            es.setplayerprop(userid, 'CPVK2Player.m_iHealth', Health+amount)
        else:
            es.setplayerprop(userid, 'CPVK2Player.m_iHealth', MaxHealth)
#End Global Methods
#Load and Unload Methods
def load():
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII Begin Load')
    for x in dnds.Class_List:
        for i in range(1, 5):
            dnds.Classes[x]['info'].append('pvkii %s %s'%(x, i))
        for y in ClassSet[x]:
            dnds.Classes[x][y] = ClassSet[x][y]
    for i in range(1, 3):
        dnds.Abilities['Constitution']['info'].append('pvkii Constitution %s'%i)
    for i in range(1, 3):
        dnds.Classes['Cleric']['powers1'].append('pvkii Cleric Powers1 %s'%i)
    if not es.exists('clientcommand','+wind'):
        es.regclientcmd('+wind','dnds/games/pvkiidnds/WindOn')
    if not es.exists('clientcommand','-wind'):
        es.regclientcmd('-wind','dnds/games/pvkiidnds/WindOff')
    for x in ['word']:
        if not es.exists('clientcommand', x):
            es.regclientcmd(x, 'dnd/games/pvkiidnds/%scmd'%(x.replace('-','')).replace('+',''))
        if not x.startswith('+') and not x.startswith('-') and not es.exists('saycommand', x):
            es.regsaycmd(x, 'dnd/games/pvkiidnds/%scmd'%x)
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII End Load')
def unload():
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII Unload Start')
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII Unload End')
ClassSet = {'Cleric':   {'health':120,
                        'armor':120,
                        'model':'player/heavyknight/heavyknight',
                        'weapons': ['weapon_twoaxe','weapon_swordshield'],
                        'ammo':{},
                        'healing surges':7},
            'Fighter':  {'health':150,
                        'armor':150,
                        'model':'player/berserker/berserker',
                        'weapons':['weapon_bigaxe','weapon_crossbow','weapon_throwaxe'],
                        'ammo':{'004':10,'007':5},
                        'healing surges':9},
            'Paladin':  {'health':150,
                        'armor':150,
                        'model':'player/heavyknight/heavyknight',
                        'weapons':['weapon_twosword','weapon_blunderbuss'],
                        'ammo':{'006':6},
                        'healing surges':10},
            'Ranger':   {'health':120,
                        'armor':100,
                        'model':'player/huscarl/huscarl',
                        'weapons':['weapon_cutlass2','weapon_axesword','weapon_longbow'],
                        'ammo':{'005':30},
                        'healing surges':6},
            'Rogue':    {'health':120,
                        'armor':80,
                        'model':'player/skirmisher/skirmisher',
                        'weapons':['weapon_cutlass','weapon_flintlock'],
                        'ammo':{'003':15},
                        'healing surges':6},
            'Warlock':  {'health':120,
                        'armor':80,
                        'model':'player/bowman/bowman',
                        'weapons':['weapon_archersword','weapon_crossbow'],
                        'ammo':{'004':4},
                        'healing surges':6},
            'Warlord':  {'health':120,
                        'armor':120,
                        'model':'player/berserker/berserker',
                        'weapons':['weapon_twosword','weapon_vikingshield','weapon_longbow'],
                        'ammo':{'005':15},
                        'healing surges':7},
            'Wizard':   {'health':100,
                        'armor':40,
                        'model':'player/captain/captain',
                        'weapons':['weapon_archersword'],
                        'ammo':{},
                        'healing surges':6}}
#End Load Methods